;WITH_FDLD       equ     1
;   IPL code of the floppy disk in  FD-IPLware system  (C) 2022 ܂
;   FDIPLwareIPLł CS:IP = 1FC0:0000 Ƀ[h. org 0h ō쐬.
FDIPLW_SEG     equ     6000h   ; HDIPLwareƓ
L_COLUMN        equ     24      ; \Jʒui[O`j
L_ROW           equ     19      ; \sʒui[Q`QQj
STACK_SIZE      equ    0F800h-2 ; X^bN̏Ԓni62KBɂĂj
XCHG_ROW        equ     23      ; 
.8086
code            segment
                assume cs:code, ds:code, es:code, ss:code
        ORG 0h
start:          ; 1024/8sect FDBPBiύXΕsj
DB 0EBh,03Ch,090h,046h,044h,049h,050h,04Ch,057h,033h,030h,000h,004h,001h,001h,000h
DB 002h,0C0h,000h,0D0h,004h,0FEh,002h,000h,008h,000h,002h,000h,000h,000h,000h,000h
DB 000h,000h,000h,000h,080h,000h,029h,01Ch,01Eh,01Dh,02Dh,046h,044h,020h,049h,050h
DB 04Ch,077h,061h,072h,065h,020h,046h,041h,054h,031h,032h,020h,020h,020h
JMP  FDboot1st
TypeFlag        DB      40h     ; Avtype COM`^BIN`(RETFEo)
TableRepeat     DB      8       ; f[^8KBubN̑傫
SegTVRAM        DW      0A000h
SP_save         DW      0       ; [JX^bN̕ۑꏊ
SS_save         DW      0
align 4
AccessTable     label   byte    ; FDANZXe[u8KBPʂōs
;       ItZbg   f[^oCg CH3CLV_  DHwbhDLZN^
;           BP          BX               CX      DX     BlockSize
Block1  DW ( 0*1024), (8*1024),         0301h,  0001h  ; 1
Block2  DW ( 8*1024), (8*1024),         0301h,  0101h  ; 2
Block3  DW (16*1024), (8*1024),         0302h,  0001h  ; 3
Block4  DW (24*1024), (8*1024),         0302h,  0101h  ; 4
Block5  DW (32*1024), (8*1024),         0303h,  0001h  ; 5
Block6  DW (40*1024), (8*1024),         0303h,  0101h  ; 6
Block7  DW (48*1024), (8*1024),         0304h,  0001h  ; 7
Block8  DW (56*1024), (8*1024),         0304h,  0101h  ; 8

FDboot1st:      
; ɗ܂ł͂Ԃ DS=0000h, SS=2000h, SP=FF??h, BP=0000h
                push    cs
                pop     ds      ; DS=CS
                xor     ax,ax
                mov     es,ax
                mov     al,es:[501h]    ; nC]`FbN
                test    al,8
                jz      @f     ; nC]̂Ƃ
                mov     SegTVRAM,0E000h ; VRAMZOgύX
        @@:     
                mov     ah,0Ch  ; eLXg\Iɂ
                int 18h

; ܂\ FD-IPLware؂[h
                mov     si,offset MsgLoading
                mov     es,SegTVRAM
IFDEF   WITH_FDLD
                mov     dl,045h    ; \FAgr[g
ELSE
                mov     dl,0A5h    ; \FAgr[g
ENDIF
                mov     di, ( (XCHG_ROW-1)*80+L_COLUMN)*2        ; 12L,14C
                mov     cx,( offset MsgLoading_E - offset MsgLoading )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

                mov     ax,FDIPLW_SEG
                mov     es,ax
                mov     BP,0000h
                mov     ax,0790h        ; 擪head seek
                int     1Bh
                
                mov     si,offset AccessTable ; ̍s͂Ȃ炸LɂĂ
                mov     ch,0
                mov     cl,TableRepeat
          @@:   
                call    ParaSet         ; 
                jc      DiskError
               loop     @b
                jnc     ReadSuccess

DiskError:
                mov     dl,045h    ; \FAgr[g
                mov     si,offset MsgDiskErr
                mov     es,SegTVRAM
                mov     di, (L_ROW*80+L_COLUMN)*2        ; 12L,14C
                mov     cx,( offset MsgDiskErr_E - offset MsgDiskErr )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b
                call    ShortBeep
                JMP     KeyEnter

ReadSuccess:    ; AvP[V̐`FbNi3.02Œǉj
                mov     ax,FDIPLW_SEG
                mov     es,ax   ; ES=6000h
                mov     di,0000h; ES:DIɂ̓_~[f[^
                mov     si,offset VerifyString  ; `FbNp
                mov     cx,10   ; 10r
          rep   cmpsb
                or      cx,cx
                jz      ValidApp        ; svȂ
                call    ShortBeep       ; x
                jmp     KeyEnter        ; u[gI

ValidApp:       ; [_s
                xor     ax,ax
                mov     bx,ax
                mov     di,ax   ; DI=BX=0
                not     ax      ; AX=FFFFh
                mov     dx,ax   ; DX=CX=FFFFh
                mov     cx,ax   ; fBXNANZXs
                mov     si,0300h ; IPLware version 3.03 

                mov     SP_save,sp
                mov     SS_save,ss

                mov     ax,FDIPLW_SEG
                mov     es,ax   ; ES=6000h
                cli
                mov     sp,STACK_SIZE
                mov     ss,ax   ; SS=6000h
                sti
                mov     bp,sp   
                test    TypeFlag,40h    ; bit 6=1:type 2
                mov     ds,ax   ; DS=ES=SS=6000h        ; Ver. 3.02
                mov     ax,0090h  ; DA/UA of 2HD FDD    ; Ver. 3.02
                jz      type1
type2: ;sJn (COM)
                mov     word ptr es:[00FCh],01E8h   ; 6000:00FC`00FFh
                mov     word ptr es:[00FEh],0CB00h  ; call 0100h,retf
                DB      9Ah             ; call far 6000:00F0h  
                DW      00FCh           ; 00FCh 
                DW      FDIPLW_SEG      ; 6000h
                jmp     UserProgramTerminated
type1: ;sJn (BIN)
                DB      9Ah             ; call far 6000:0100h  
                DW      0100h           ; 0100h 
                DW      FDIPLW_SEG      ; 6000h
UserProgramTerminated:  ;   RETFłɖ߂ė
                cli
                mov     sp,cs:SP_save
                mov     ss,cs:SS_save
                sti     
                push    cs
                pop     ds

KeyEnter:       ; \NA[u[hv
                mov     es,SegTVRAM
                mov     ax,0020h
                mov     si,offset MsgLoading
                mov     dl,0E1h    ; \FAgr[g
                mov     di, ( (XCHG_ROW-1)*80+L_COLUMN)*2        ; 12L,14C
                mov     cx,( offset MsgLoading_E - offset MsgLoading )/2+12
        @@:     mov     es:[di+2000h],dl
                stosw
               loop     @b

;FDbZ[Ws\
;               mov     es,SegTVRAM     ; pĂ̂ŏȗ
                mov     al,25h      ; obN
                call    ClrAttrArea ;
                mov     si,offset MsgExchangeFD
                mov     dl,0C3h     ; ̐FAgr[g
                mov     di, ( XCHG_ROW*80+2)*2        ; 22L,10C
                mov     cx,( offset MsgExchangeFD_E - offset MsgExchangeFD )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

;               mov     es,SegTVRAM     ; pĂ̂ŏȗ
                mov     si,offset MsgDev
                mov     dl,025h ; FAgr[g
                mov     di, ( (1+XCHG_ROW)*80+16)*2
                mov     cx,( offset MsgDev_E - offset MsgDev )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

; L[҂
KeyEnter2:      
                xor     ax,ax
                int     18h
                cmp     al,0Dh  ; [s]L[ꂽ
                je      NbootAll
                cmp     ah,1Dh  ; [A]L[ꂽ-->IDE#1N
                je      NbootSASI
                cmp     ah,01h  ; [1]L[ꂽ-->IDE#1N
                je      NbootSASI
                cmp     ah,02h  ; [2]L[ꂽ-->IDE#2N
                je      NbootSASI2
                cmp     ah,1Eh  ; [S]L[ꂽ-->SCSIN
                je      NbootSCSI
                cmp     ah,20h  ; [F]L[ꂽ-->FD2HDN
                je      NbootFD2HD
                cmp     ah,2Fh  ; [M]L[ꂽ-->MON
                je      NbootMO
                cmp     ah,2Dh  ; [B]L[ꂽ-->ROM BASICN
                je      NbootROMBASIC   ; 2022-7-17 ver. 3.1
                cmp     ah,10h  ; [Q]L[ꂽipsj
                je      ExitDOS
                call    ShortBeep1
                jmp     KeyEnter2

; ; Ux 1990N2 pp37-43  ALAH܂ł̃foCXTH
NbootROMBASIC:  mov     ax,0000h
                DB      0EAh            ; 2022-7-17 ver. 3.1
                DW      0000h
                DW      0E800h          ; jmp far E800:0000
NbootFD2HD:     mov     ax,0801h
                jmp     DiskBoot
NbootSASI:      mov     ax,0A0Ah
                jmp     DiskBoot
NbootSASI2:     mov     ax,0B0Bh
                jmp     DiskBoot
NbootSCSI:      mov     ax,0C0Ch
                jmp     DiskBoot
NbootMO:        mov     ax,0E0Eh        ; 񔭌 2022-5-20
                jmp     DiskBoot
NbootAll:       mov     ax,0C01h        ; AH=0C(SCSI), AL=01(FDD-2HD)

DiskBoot:       
                push    ax
                mov     dx,0E120h
                mov     ah,16h          ; eLXgʏ
                int     18h
                xor     ax,ax
                mov     ds,ax           ; DS=0ɂ
                pop     ax
                test    byte ptr ds:[0501h],8
                jnz     HiresoBoot
                DB  0EAh,0E8h,27h,80h,0FDh ; m[}[h ecu[gFD80:27E8 
HiresoBoot:
                DB  0EAh,0ECh,7Fh,00h,0F8h ; nC] u[gF800:7FECh
;====================== ŃfBXNu[gɔ==============
ExitDOS:        ; DOSɖ߂
                RETF     ; ߂iԂsvj
;----------------------------------------------------------------
ParaSet         PROC   near     ;  e[ǔ݈ʒuwsi
                push    cx
                lodsw
                mov     bp,ax
                lodsw
                mov     bx,ax
                lodsw
                mov     cx,ax
                lodsw
                mov     dx,ax
                mov     ax,5690h
                push    si      ; Ôߕۑ
                int     1Bh
                pop     si
                pop     cx
                ret
ParaSet         ENDP
;----------------------------------------------------------------
ShortBeep1:     mov     cx,3000h
                jmp     ShortBeep0

ShortBeep       PROC   near
                mov     cx,0F000h
ShortBeep0:
                push    ax
                mov     al,6h
                out     37h,al
          @@:   out     5Fh,al
                out     5Fh,al
               loop     @b
                mov     al,7h
                out     37h,al
                pop     ax
                ret
ShortBeep       ENDP
;----------------------------------------------------------------

ClrAttrArea     PROC   near     ; input al=attribute code
                mov     es,SegTVRAM
                mov     di,22*80*2  ; 22sڂ 
                mov     cx,80*3     ; 3sԂ 22,23,24L
                mov     dl,al       ; ALŎĂAgr[gR[h
                mov     ax,0020h    ; 󔒔p
         @@:    mov     es:[di+2000h],dl  ; Agr[gR[h
                stosw   ; R[h
               loop @b
                ret
ClrAttrArea     ENDP
;----------------------------------------------------------------

ifdef   WITH_FDLD
MsgLoading       label   byte
;uFDloaderع DISKdesuv
  DW 0,0046h,0044h,006Ch,006Fh,0061h,0064h,0065h,0072h,00B1h,00CCh,00DFh
  DW 00D8h,00B9h,00B0h,00BCh,00AEh,00DDh,0020h,0044h,0049h,0053h,004Bh,4704h
  DW 4784h,3904h,3984h,0000h
MsgLoading_E     label   byte
ELSE
MsgLoading       label   byte
;uFD-IPLwareع ۰ޒv
  DW  0,0046h,0044h,002Dh,0049h,0050h,004Ch,0077h,0061h,0072h,0065h,00B1h
  DW  00CCh,00DFh,00D8h,00B9h,00B0h,00BCh,00AEh,00DDh,0020h,00DBh,00B0h,00C4h
  DW  00DEh,6623h,66A3h,0
MsgLoading_E     label   byte
ENDIF

;ufBXNǂݍ݂ŃG[܂v
MsgDiskErr      label   byte
DW 2101h,2181h
DW  4705h,4785h,2305h,2385h,3905h,3985h,2F05h,2F85h,4926h,49A6h,5F04h,5F84h
DW  7E19h,7E99h,5F04h,5F84h,4704h,4784h,2805h,2885h,6905h,6985h,3C01h,3C81h
DW  2C04h,2C84h,2204h,2284h,6A04h,6A84h,5E04h,5E84h,3704h,3784h,3F04h,3F84h
DW 2101h,2181h
MsgDiskErr_E    label   byte

;utbs[fBXNnrNp̂̂ɌĂAEnterL[ĉ.v
MsgExchangeFD label byte
  DW  5505h,5585h,6D05h,6D85h,4305h,4385h,5405h,5485h,3C01h,3C81h,4705h,4785h
  DW  2305h,2385h,3905h,3985h,2F05h,2F85h,7204h,7284h,4F03h,4F83h,5303h,5383h
  DW  2F15h,2F95h,3026h,30A6h,512Dh,51ADh,4E04h,4E84h,6204h,6284h,4E04h,4E84h
  DW  4B04h,4B84h,7218h,7298h,3914h,3994h,3704h,3784h,4604h,4684h,2B04h,2B84h
  DW  6904h,6984h,2201h,2281h,0045h,006Eh,0074h,0065h,0072h,2D05h,2D85h,3C01h
  DW  3C81h,7204h,7284h,2112h,2192h,3704h,3784h,4604h,4684h,3C12h,3C92h,3504h
  DW  3584h,2404h,2484h,002Eh
MsgExchangeFD_E label byte

MsgDev label byte
;;;uFFD, AIDE, SSCSI, MMO, BROM BASICNv
  DW  0046h,4704h,4784h,0046h,0044h,002Ch,0020h,0041h,4704h,4784h,0049h,0044h
  DW  0045h,002Ch,0020h,0053h,4704h,4784h,0053h,0043h,0053h,0049h,002Ch,0020h
  DW  004Dh,4704h,4784h,004Dh,004Fh,002Ch,0020h,0042h,4704h,4784h,0052h,004Fh
  DW  004Dh,0020h,0042h,0041h,0053h,0049h,0043h
  DW  2B04h,2B84h,6904h,6984h,2F15h,2F95h,3026h,30A6h
MsgDev_E label byte
DB      0
VerifyString    DB      "FD-IPLware application program",0
;VersionString   DB      "3.10",0,"2022-7-17",0
;VersionString   DB      "3.12",0,"2023-1-23",0
VersionString   DB      "3.14",0,"2023-2-15",0
DB      64 dup (0)
org     400h    ;u[gZN^@PZN^̏I
;-------------ȍ~ɋLqĂ͂ȂȂ------------
code    ends
        end start
END
